# Google

Com o Web Scraper API, você pode fazer scraping e analisar vários tipos de **Google** páginas; abaixo está uma visão geral de todos os scrapers compatíveis e seus respectivos `source` valores.

<table><thead><tr><th width="260">Fonte</th><th>Descrição</th><th>Parser dedicado</th></tr></thead><tbody><tr><td><code>google_search</code></td><td>SERPs. (<a href="/pages/b2214cbbb580271e42a5b114203f33d01beb5cc0"><strong>Web</strong></a>, <a href="/pages/dee2a8ed62bd0e533c4f6cff4fa6afaf665733a1"><strong>Imagem</strong></a>, <a href="/pages/d918036d393222a3e9bdc19d4b2b33b1d33354df"><strong>Notícias</strong></a><strong>,</strong> <a href="/pages/02dfa7dcc552389ff606aa892e52e8b09301270c"><strong>AI Overviews</strong></a>)</td><td>Sim.</td></tr><tr><td><code>google_ads</code></td><td>SERPs, otimizadas para <a href="/pages/f5706a2de8eec8034e1d61bb9cb2952350b7bae3"><strong>taxa máxima de anúncios</strong></a>.</td><td>Sim.</td></tr><tr><td><code>google_ai_mode</code></td><td><a href="/pages/915de8adb20cd1495c1d27afd659254bc44a84a1"><strong>Modo de IA do Google</strong></a>  respostas conversacionais.</td><td>Sim.</td></tr><tr><td><code>google_lens</code></td><td><a href="/pages/0e8e98af78052143c36f7088b52461c02d80c53f"><strong>Google Lens</strong></a> serviço.</td><td>Sim.</td></tr><tr><td><code>google_maps</code></td><td><a href="/pages/e30ce2fdbf5cc3e89d69706a8e4d23a9ea4efbaf"><strong>Pesquisa local</strong></a> serviço.</td><td>Não.</td></tr><tr><td><code>google_trends_explore</code></td><td><a href="/pages/2c36737f24ab42484aa815d02828bde69056051f"><strong>Tendências</strong></a>.</td><td>Não.</td></tr><tr><td><code>google_travel_hotels</code></td><td><a href="/pages/0797ae2e3969ecfd5ec99881f52e425fd241aeff"><strong>Viagens: Hotéis</strong></a> serviço.</td><td>Não.</td></tr><tr><td><code>google_shopping_product</code></td><td><a href="/pages/049d820c363f2e85396d2f05e09d2ea10adbf151"><strong>Produto</strong></a> página de um token de produto de sua escolha.</td><td>Sim.</td></tr><tr><td><code>google_shopping_search</code></td><td><a href="/pages/d8d7576853dcff6e67f5531b50dedd0a81b41d03"><strong>Pesquisa</strong></a> resultados para um termo de pesquisa de sua escolha.</td><td>Sim.</td></tr><tr><td><code>google</code></td><td>Enviar qualquer Google <a href="/pages/bfa6b3427d0b6b1d06fc48a5152291d9b36ba369"><strong>URL</strong></a> que quiser.</td><td>Limitado a URLs de tipos específicos <a href="/pages/7a124cd3d2ac6d7bd90b758b93df602722bf2157"><strong>tipos de página do Google</strong></a>.</td></tr></tbody></table>

{% hint style="info" %}
Embora não tenhamos analisadores dedicados para cada fonte do Google, você pode escrever suas próprias instruções de parsing com [**Custom Parser**](/products/pt-br/web-scraper-api/features/custom-parser.md) recurso e obtenha dados estruturados.
{% endhint %}

## Primeiros passos

**Crie suas credenciais de usuário da API**: Cadastre-se para uma avaliação gratuita ou compre o produto no [**painel da Oxylabs**](https://dashboard.oxylabs.io/en/registration) para criar suas credenciais de usuário da API (`USERNAME` e `PASSWORD`).

{% hint style="warning" %}
Se você precisar de mais de um usuário de API para sua conta, entre em contato com nosso [**suporte ao cliente**](mailto:support@oxylabs.io) ou envie uma mensagem para nosso suporte por chat ao vivo 24/7.
{% endhint %}

### Exemplo de solicitação

{% tabs %}
{% tab title="cURL" %}

```shell
curl 'https://realtime.oxylabs.io/v1/queries' \
--user 'USERNAME:PASSWORD' \
-H 'Content-Type: application/json' \
-d '{
        "source": "google_search",
        "query": "adidas",
        "geo_location": "California,United States",
        "parse": true
    }'
```

{% endtab %}

{% tab title="Python" %}

```python
import requests
from pprint import pprint

# Estruture o payload.
payload = {
    'source': 'google_search',
    'query': 'adidas',
    'geo_location': 'California,United States',
    'parse': True
}

# Obtenha a resposta.
response = requests.request(
    'POST',
    'https://realtime.oxylabs.io/v1/queries',
    auth=('USERNAME', 'PASSWORD'),
    json=payload,
)

# Imprima a resposta formatada em stdout.
pprint(response.json())
```

{% endtab %}

{% tab title="Node.js" %}

```javascript
const https = require("https");

const username = "USERNAME";
const password = "PASSWORD";
const body = {
    source: "google_search",
    query: "adidas",
    geo_location: "California,United States",
    parse: true,
};

const options = {
    hostname: "realtime.oxylabs.io",
    path: "/v1/queries",
    method: "POST",
    headers: {
        "Content-Type": "application/json",
        Authorization:
            "Basic " + Buffer.from(`${username}:${password}`).toString("base64"),
    },
};

const request = https.request(options, (response) => {
    let data = "";

    response.on("data", (chunk) => {
        data += chunk;
    });

    response.on("end", () => {
        const responseData = JSON.parse(data);
        console.log(JSON.stringify(responseData, null, 2));
    });
});

request.on("error", (error) => {
    console.error("Error:", error);
});

request.write(JSON.stringify(body));
request.end();
```

{% endtab %}

{% tab title="PHP" %}

```php
<?php

$params = array(
    'source' => 'google_search',
    'query' => 'adidas',
    'geo_location' => 'California,United States',
    'parse' => true
);

$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, "https://realtime.oxylabs.io/v1/queries");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($params));
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_USERPWD, "USERNAME" . ":" . "PASSWORD");

$headers = array();
$headers[] = "Content-Type: application/json";
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

$result = curl_exec($ch);
echo $result;

if (curl_errno($ch)) {
    echo 'Error:' . curl_error($ch);
}
curl_close($ch);
```

{% endtab %}

{% tab title="C#" %}

```csharp
using System;
using System.Net.Http;
using System.Net.Http.Json;
using System.Threading.Tasks;

namespace OxyApi
{
    class Program
    {
        static async Task Main()
        {
            const string Username = "USERNAME";
            const string Password = "PASSWORD";

            var parameters = new {
                source = "google_search",
                query = "adidas",
                geo_location = "California,United States",
                parse = true
            };

            var client = new HttpClient();

            Uri baseUri = new Uri("https://realtime.oxylabs.io");
            client.BaseAddress = baseUri;

            var requestMessage = new HttpRequestMessage(HttpMethod.Post, "/v1/queries");
            requestMessage.Content = JsonContent.Create(parameters);

            var authenticationString = $"{Username}:{Password}";
            var base64EncodedAuthenticationString = Convert.ToBase64String(System.Text.Encoding.ASCII.GetBytes(authenticationString));
            requestMessage.Headers.Add("Authorization", "Basic " + base64EncodedAuthenticationString);

            var response = await client.SendAsync(requestMessage);
            var contents = await response.Content.ReadAsStringAsync();

            Console.WriteLine(contents);
        }
    }
}
```

{% endtab %}

{% tab title="Golang" %}

```go
package main

import (
	"bytes"
	"encoding/json"
	"fmt"
	"io/ioutil"
	"net/http"
)

func main() {
	const Username = "USERNAME"
	const Password = "PASSWORD"

	payload := map[string]interface{}{
		"source":       "google_search",
		"query":        "adidas",
		"geo_location": "California,United States",
		"parse":        true,
	}

	jsonValue, _ := json.Marshal(payload)

	client := &http.Client{}
	request, _ := http.NewRequest("POST",
		"https://realtime.oxylabs.io/v1/queries",
		bytes.NewBuffer(jsonValue),
	)

	request.SetBasicAuth(Username, Password)
	request.Header.Set("Content-Type", "application/json")
	response, _ := client.Do(request)

	responseText, _ := ioutil.ReadAll(response.Body)
	fmt.Println(string(responseText))
}
```

{% endtab %}

{% tab title="HTTP" %}

```http
https://realtime.oxylabs.io/v1/queries?source=google_search&query=adidas&geo_location=California%2CUnited%20States&parse=true&access_token=12345abcde
```

{% endtab %}

{% tab title="Java" %}

```java
package org.example;

import okhttp3.*;
import org.json.JSONObject;
import java.util.concurrent.TimeUnit;

public class Main implements Runnable {
    private static final String AUTHORIZATION_HEADER = "Authorization";
    public static final String USERNAME = "USERNAME";
    public static final String PASSWORD = "PASSWORD";

    public void run() {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("source", "google_search");
        jsonObject.put("query", "adidas");
        jsonObject.put("geo_location", "California,United States");
        jsonObject.put("parse", true);

        Authenticator authenticator = (route, response) -> {
            String credential = Credentials.basic(USERNAME, PASSWORD);
            return response
                    .request()
                    .newBuilder()
                    .header(AUTHORIZATION_HEADER, credential)
                    .build();
        };

        var client = new OkHttpClient.Builder()
                .authenticator(authenticator)
                .readTimeout(180, TimeUnit.SECONDS)
                .build();

        var mediaType = MediaType.parse("application/json; charset=utf-8");
        var body = RequestBody.create(jsonObject.toString(), mediaType);
        var request = new Request.Builder()
                .url("https://realtime.oxylabs.io/v1/queries")
                .post(body)
                .build();

        try (var response = client.newCall(request).execute()) {
            if (response.body() != null) {
                try (var responseBody = response.body()) {
                    System.out.println(responseBody.string());
                }
            }
        } catch (Exception exception) {
            System.out.println("Error: " + exception.getMessage());
        }

        System.exit(0);
    }

    public static void main(String[] args) {
        new Thread(new Main()).start();
    }
}
```

{% endtab %}

{% tab title="JSON" %}

```json
{
    "source": "google_search",
    "query": "adidas",
    "geo_location": "California,United States",
    "parse": true
}
```

{% endtab %}
{% endtabs %}

{% file src="/files/506680b423a62147dfecea0b8cc64abe2f9696db" %}

Usamos o método de integração [**Realtime**](/products/pt-br/web-scraper-api/integration-methods/realtime.md) síncrona em nossos exemplos. Se você quiser usar [**Proxy Endpoint**](/products/pt-br/web-scraper-api/integration-methods/proxy-endpoint.md) ou a integração assíncrona [**Push-Pull**](/products/pt-br/web-scraper-api/integration-methods/push-pull.md) , consulte a seção [**métodos de integração**](/products/pt-br/web-scraper-api/integration-methods.md) .

Opcionalmente, você pode incluir parâmetros adicionais como `geo_location`, `user_agent_type`, `parse`, `render` e mais para personalizar sua solicitação de scraping. Leia mais:


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://developers.oxylabs.io/api-targets/pt-br/mecanismos-de-busca/google.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
